﻿using Microsoft.DirectX.DirectSound;
using System;

namespace BeepMap {
    class sndDirectSound : ISndPlay {
        bool initialized = false;
        Device DSDevice;
        WaveFormat waveFormat;
        BufferDescription bufferDesc;
        SecondaryBuffer secondaryBuffer;

        public sndDirectSound(System.Windows.Forms.Control owner) {
            DSDevice = new Device();
            DSDevice.SetCooperativeLevel(owner, CooperativeLevel.Normal);
        }

        public void Play(int rate, int length, short[] data) {
            // stop audio if it's playing
            Stop();

            // wave format description
            waveFormat = new WaveFormat();
            waveFormat.BitsPerSample = 16;
            waveFormat.SamplesPerSecond = rate;
            waveFormat.Channels = 1;
            waveFormat.BlockAlign = 2;
            waveFormat.FormatTag = WaveFormatTag.Pcm;
            waveFormat.AverageBytesPerSecond = waveFormat.SamplesPerSecond * waveFormat.BlockAlign;

            // buffer description
            bufferDesc = new BufferDescription(waveFormat);
            bufferDesc.DeferLocation = true;
            bufferDesc.BufferBytes = length * 2;

            // create buffer
            secondaryBuffer = new SecondaryBuffer(bufferDesc, DSDevice);

            // ready to go!
            initialized = true;

            // load samples to the buffer and play
            secondaryBuffer.Write(0, data, LockFlag.EntireBuffer);
            secondaryBuffer.Play(0, BufferPlayFlags.Default);
        }

        public void Stop() {
            if(initialized) secondaryBuffer.Stop();
        }
    }
}
